/**
    (C) Copyright 2011 Dominik Wagenfuehr

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation; either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this program. If not, see
    <http://www.gnu.org/licenses/>.
*/

#include "semirandomstrategy.hh"

#include <cstdlib>
#include <ctime>

// Konstruktor
SemiRandomStrategy::SemiRandomStrategy()
: BaseStrategy()
{
    // Zufallszahlen initialisieren
    srand(time(0));
}

// Destructor.
SemiRandomStrategy::~SemiRandomStrategy()
{
}

// Erstellt eine Kopie des Elements.
BaseStrategy* SemiRandomStrategy::copy() const
{
    return (BaseStrategy*)(new SemiRandomStrategy(*this));
}

// Akzeptiert oder lehnt ein Angebot ab.
bool SemiRandomStrategy::acceptOrDeclineOffer( const int value )
{
    bool acceptOffer = false;

    if ( value >= 500 )
    {
        acceptOffer = true;
    }
    else
    {
        // Per Zufall entscheiden, ob angenommen wird.
        const int decision = rand()%2;
        if ( decision == 1 )
        {
            acceptOffer = true;
        }
    }
    return acceptOffer;
}

// Berechnet die angebotenen Punkte und sendet sie an den Server.
int SemiRandomStrategy::calculateOfferedPoints()
{
    // Zufallswert zwischen 0 und 500 anbieten.
    return ( rand()%501 );
}
